// ##### ENDFILE "SnapshotChangedEventWrap.cpp"


// ##### BEGINFILE "MouseCapabilityChangedEventWrap.cpp"
/** @file
 * VirtualBox API class wrapper code for IMouseCapabilityChangedEvent.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#define LOG_GROUP_MAIN_OVERRIDE LOG_GROUP_MAIN_MOUSECAPABILITYCHANGEDEVENT

#include "MouseCapabilityChangedEventWrap.h"
#include "Logging.h"
#ifdef VBOX_WITH_DTRACE_R3_MAIN
# include "dtrace/VBoxAPI.h"
#endif

DEFINE_EMPTY_CTOR_DTOR(MouseCapabilityChangedEventWrap)

//
// IEvent properties
//

STDMETHODIMP MouseCapabilityChangedEventWrap::COMGETTER(Type)(VBoxEventType_T *aType)
{
    LogRelFlow(("{%p} %s: enter aType=%p\n", this, "MouseCapabilityChangedEvent::getType", aType));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aType);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_TYPE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getType(aType);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 0 /*normal*/,*aType);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 1 /*hrc exception*/,*aType);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 9 /*unhandled exception*/,*aType);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aType=%RU32 hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::getType", *aType, hrc));
    return hrc;
}

STDMETHODIMP MouseCapabilityChangedEventWrap::COMGETTER(Source)(IEventSource **aSource)
{
    LogRelFlow(("{%p} %s: enter aSource=%p\n", this, "MouseCapabilityChangedEvent::getSource", aSource));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSource);
        ComTypeOutConverter<IEventSource> TmpSource(aSource);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SOURCE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSource(TmpSource.ptr());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 0 /*normal*/,(void *)TmpSource.ptr());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSource=%p hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::getSource", *aSource, hrc));
    return hrc;
}

STDMETHODIMP MouseCapabilityChangedEventWrap::COMGETTER(Waitable)(BOOL *aWaitable)
{
    LogRelFlow(("{%p} %s: enter aWaitable=%p\n", this, "MouseCapabilityChangedEvent::getWaitable", aWaitable));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aWaitable);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_WAITABLE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getWaitable(aWaitable);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 0 /*normal*/,*aWaitable != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 1 /*hrc exception*/,*aWaitable != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 9 /*unhandled exception*/,*aWaitable != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aWaitable=%RTbool hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::getWaitable", *aWaitable, hrc));
    return hrc;
}

//
// IMouseCapabilityChangedEvent properties
//

STDMETHODIMP MouseCapabilityChangedEventWrap::COMGETTER(SupportsAbsolute)(BOOL *aSupportsAbsolute)
{
    LogRelFlow(("{%p} %s: enter aSupportsAbsolute=%p\n", this, "MouseCapabilityChangedEvent::getSupportsAbsolute", aSupportsAbsolute));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSupportsAbsolute);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSABSOLUTE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSupportsAbsolute(aSupportsAbsolute);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSABSOLUTE_RETURN(this, hrc, 0 /*normal*/,*aSupportsAbsolute != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSABSOLUTE_RETURN(this, hrc, 1 /*hrc exception*/,*aSupportsAbsolute != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSABSOLUTE_RETURN(this, hrc, 9 /*unhandled exception*/,*aSupportsAbsolute != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSupportsAbsolute=%RTbool hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::getSupportsAbsolute", *aSupportsAbsolute, hrc));
    return hrc;
}

STDMETHODIMP MouseCapabilityChangedEventWrap::COMGETTER(SupportsRelative)(BOOL *aSupportsRelative)
{
    LogRelFlow(("{%p} %s: enter aSupportsRelative=%p\n", this, "MouseCapabilityChangedEvent::getSupportsRelative", aSupportsRelative));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSupportsRelative);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSRELATIVE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSupportsRelative(aSupportsRelative);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSRELATIVE_RETURN(this, hrc, 0 /*normal*/,*aSupportsRelative != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSRELATIVE_RETURN(this, hrc, 1 /*hrc exception*/,*aSupportsRelative != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSRELATIVE_RETURN(this, hrc, 9 /*unhandled exception*/,*aSupportsRelative != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSupportsRelative=%RTbool hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::getSupportsRelative", *aSupportsRelative, hrc));
    return hrc;
}

STDMETHODIMP MouseCapabilityChangedEventWrap::COMGETTER(SupportsMultiTouch)(BOOL *aSupportsMultiTouch)
{
    LogRelFlow(("{%p} %s: enter aSupportsMultiTouch=%p\n", this, "MouseCapabilityChangedEvent::getSupportsMultiTouch", aSupportsMultiTouch));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSupportsMultiTouch);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSMULTITOUCH_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSupportsMultiTouch(aSupportsMultiTouch);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSMULTITOUCH_RETURN(this, hrc, 0 /*normal*/,*aSupportsMultiTouch != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSMULTITOUCH_RETURN(this, hrc, 1 /*hrc exception*/,*aSupportsMultiTouch != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_SUPPORTSMULTITOUCH_RETURN(this, hrc, 9 /*unhandled exception*/,*aSupportsMultiTouch != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSupportsMultiTouch=%RTbool hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::getSupportsMultiTouch", *aSupportsMultiTouch, hrc));
    return hrc;
}

STDMETHODIMP MouseCapabilityChangedEventWrap::COMGETTER(NeedsHostCursor)(BOOL *aNeedsHostCursor)
{
    LogRelFlow(("{%p} %s: enter aNeedsHostCursor=%p\n", this, "MouseCapabilityChangedEvent::getNeedsHostCursor", aNeedsHostCursor));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aNeedsHostCursor);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_NEEDSHOSTCURSOR_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getNeedsHostCursor(aNeedsHostCursor);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_NEEDSHOSTCURSOR_RETURN(this, hrc, 0 /*normal*/,*aNeedsHostCursor != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_NEEDSHOSTCURSOR_RETURN(this, hrc, 1 /*hrc exception*/,*aNeedsHostCursor != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_GET_NEEDSHOSTCURSOR_RETURN(this, hrc, 9 /*unhandled exception*/,*aNeedsHostCursor != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aNeedsHostCursor=%RTbool hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::getNeedsHostCursor", *aNeedsHostCursor, hrc));
    return hrc;
}


//
// IEvent methods
//

STDMETHODIMP MouseCapabilityChangedEventWrap::SetProcessed()
{
    LogRelFlow(("{%p} %s:enter\n", this, "MouseCapabilityChangedEvent::setProcessed"));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {



#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_SETPROCESSED_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setProcessed();
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 0 /*normal*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::setProcessed", hrc));
    return hrc;
}

STDMETHODIMP MouseCapabilityChangedEventWrap::WaitProcessed(LONG aTimeout,
                                                            BOOL *aResult)
{
    LogRelFlow(("{%p} %s:enter aTimeout=%RI32 aResult=%p\n", this, "MouseCapabilityChangedEvent::waitProcessed", aTimeout, aResult));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aResult);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_WAITPROCESSED_ENTER(this, aTimeout);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = waitProcessed(aTimeout,
                                aResult);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 0 /*normal*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_MOUSECAPABILITYCHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/, aTimeout, *aResult != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave aResult=%RTbool hrc=%Rhrc\n", this, "MouseCapabilityChangedEvent::waitProcessed", *aResult, hrc));
    return hrc;
}

//
// IMouseCapabilityChangedEvent methods
//

#ifdef VBOX_WITH_XPCOM
NS_DECL_CLASSINFO(MouseCapabilityChangedEventWrap)
NS_IMPL_THREADSAFE_ISUPPORTS2_CI(MouseCapabilityChangedEventWrap, IMouseCapabilityChangedEvent, IEvent)
#endif // VBOX_WITH_XPCOM

